package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.diapersgetrecord.ElderlyDiapersGetRecordPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.diapersgetrecord.ElderlyDiapersGetRecordRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.diapersgetrecord.ElderlyDiapersGetRecordSaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyDiapersGetRecordService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 尿不湿领取记录")
@RestController
@RequestMapping("/elderly-diapers-get-record")
@Validated
public class ElderlyDiapersGetRecordController {

    @Resource
    private ElderlyDiapersGetRecordService elderlyDiapersGetRecordService;

    @PostMapping("/create")
    @Operation(summary = "创建尿不湿领取记录")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyDiapersGetRecordSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyDiapersGetRecordService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新尿不湿领取记录")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyDiapersGetRecordSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyDiapersGetRecordService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除尿不湿领取记录")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyDiapersGetRecordService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得尿不湿领取记录详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyDiapersGetRecordRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyDiapersGetRecordService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得尿不湿领取记录分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyDiapersGetRecordRespVO>> page(@Valid ElderlyDiapersGetRecordPageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyDiapersGetRecordService.getPage(pageReqVO));
    }
}
